View Issue Details

IDProjectCategoryView StatusLast Update
0001562SymmetricDSBugpublic2014-02-15 14:20
ReporterdavemeloAssigned Tochenson 
Prioritynormal 
Status resolvedResolutionfixed 
Product Version3.5.16 
Target Version3.5.17Fixed in Version3.5.17 
Summary0001562: Routing using TransactionId causes bad routing when H2 DB is restarted
DescriptionWhen uses default algorithm for routing in the channels (transactional=true), if you are in H2 DataBase (could happend in more databases), if the DB restarts without made the routing, the transaction Id could be repeated again in future transactions, so when the jobs route data, it is routing basing the transaction id, that could be the same for data that was captured in differents restarts of database and symmetricsds get an error because it routes in bad order.

You can see getTransactionId of H2 (The value is unique across database restarts (values are not re-used):

http://www.h2database.com/html/functions.html#transaction_id

TagsNo tags attached.

Activities

chenson

2014-02-05 16:24

administrator   ~0000460

Good catch. I'm going to append a static timestamp to the end of the TRANSACTION_ID() method call so the captured transaction ids will look like this:

2-149-3-1391635232309

Related Changesets

SymmetricDS: master 992d8aa3

2014-02-05 16:21:59

chenson

Details Diff
Fixed 0001562: Routing using TransactionId causes bad routing when H2 DB is restarted
0001562
mod - symmetric-client/src/main/java/org/jumpmind/symmetric/db/h2/H2SymmetricDialect.java Diff File
mod - symmetric-client/src/main/java/org/jumpmind/symmetric/db/h2/H2Trigger.java Diff File

Issue History

Date Modified Username Field Change
2014-02-05 11:44 davemelo New Issue
2014-02-05 16:24 chenson Note Added: 0000460
2014-02-05 16:24 chenson Assigned To => chenson
2014-02-05 16:24 chenson Status new => assigned
2014-02-05 16:24 chenson Product Version => 3.5.16
2014-02-05 16:24 chenson Fixed in Version => 3.5.17
2014-02-05 16:24 chenson Target Version => 3.5.17
2014-02-05 16:24 chenson Status assigned => resolved
2014-02-05 16:24 chenson Resolution open => fixed
2014-02-05 17:00 Changeset attached => SymmetricDS trunk r7923
2014-02-15 14:20 chenson Status resolved => closed
2015-07-30 21:49 chenson Changeset attached => SymmetricDS master 992d8aa3
2015-07-30 21:50 chenson Status closed => resolved